//======================================================================
// XΖ@ɂA֐̍œKT[`GW̃NX
// 
// RXg֐ŏɂȂp[^T
//
// T
// http://www.sist.ac.jp/~suganuma/kougi/other_lecture/SE/ 
// Aconjugate_j.txt 狤z@JavavO
// Rs[āAu`̉Kpɉρ@ 2008.10.08 H.Kimura
//                                                                     |
//  Copyright 2008 Hajime Kimura, Kyushu Univ.                         |
//  http://sysplan.nams.kyushu-u.ac.jp/gen/index.html
//======================================================================
import java.lang.Math ;
import java.io.*;
import java.util.Vector ; // IuWFNgTCY̊gEksNX
import java.util.*;
// import MT19937 ;
// import FitnessFunction ;

public class Conjugate { 
	//-----------------------Ow肳p[^
	public int    n;            // œKp[^xNg̎
	public int    param_dim;    // œKp[^xNg̎
	//-----
	double eps ;  // :                            
	double step ; //: ݕ                                

	double y[]   ; // ŏl                                    
	double x[]   ; // x(lƓ)   
	double dx[]  ; // ֐̔l      
	Kansu kn     ; // ֐lCW̌vZNX
	public FitnessFunction objectiveFunc   ;// ړI֐

	double b ; // = 0.0 
	double f1 ;
	double f2 ;
	double g[] ;
	double k ;
	double s1 ; // = 1.0
	double s2 ;
	double sp ;
	double y1[] ; // = new double [1], 
	double y2[] ; // = new double [1];
	int max ; // CT[`ɂőT
	int i1 ;
	int sw ; // = 0 ;
	int sw1[] ; // = new int [1];
	int count ;

	//RXgN^------------------------------------------------
	Conjugate( FitnessFunction InpFitnessFunction, 
				double delta, // ŋߎƂ̍ݕ
				int max_i,    // CT[`ɂT񐔂̍ől
				double eps_i, //       
				double step_i // ݕ
		){ 
		//-------------------
		objectiveFunc = InpFitnessFunction ;
		objectiveFunc.Init() ;
		//---------Tׂp[^̎ݒ
		n  = objectiveFunc.GetParameterDimension() ;
		param_dim = n ;
		//----֐lCW̌vZNXݒ
		if( delta <= 0 ){ delta = 0.000001;}
		kn = new Kansu( objectiveFunc, delta );
		//-----
		max = max_i ;
		if ( max < 1 ){ max = 100;}
		y     = new double[n]; // ŏl                                    
		x     = new double[n]; // x(lƓ)   
		dx    = new double[n]; // ֐̔l      
		eps   = eps_i ;
		if( eps <= 0 ){ eps = delta * 0.1;} 
		step  = step_i;
		if( step <= 0 ){ step = delta * 10;} 
		//------
		b = 0.0 ;
		g     = new double [n];
		s1    = 1.0 ; 
		y1    = new double [1]; 
		y2    = new double [1];
		sw    = 0 ;
		sw1   = new int [1];
		y1[0] = kn.snx(0.0, x, dx);
		count = 0;
	}
	//-----------------------------------------------------------------
	public int init(){
		double band ;
		double tmp ;
		for( int index = 0; index < n ; index++ ){
			band =  objectiveFunc.GetParameterUpperBound(index);
			band -= objectiveFunc.GetParameterLowerBound(index);
			band *= MT19937.uniform();    // 0-1̈l|
			tmp = objectiveFunc.GetParameterLowerBound(index);
			x[index] = tmp + band;
		}
		y1[0] = kn.snx(0.0, x, dx);
		return( 0 );
	}

	//=====================================
	double executeOneLoop(){
		//---------X̌vZ
		kn.dsnx(x, g);
		//---------X̃`FbN
		s2 = 0.0;
		for (i1 = 0; i1 < n; i1++){
			s2 += g[i1] * g[i1];
		}
		//---̌vZ
		count++ ;
		if (count%n == 1){
			b = 0.0;
		}else{
			b = s2 / s1;
		}
		for (i1 = 0; i1 < n; i1++){
			dx[i1] = g[i1] + b * dx[i1];
		}
		//------------PœKs
		// Ԃ߂
		sw1[0] = 0;
		f1     = y1[0];
		sp     = step;
		f2     = kn.snx(sp, x, dx);
		if (f2 > f1){
			sp = -step;
		}
		for (i1 = 0; i1 < max && sw1[0] == 0; i1++) {
			f2 = kn.snx(sp, x, dx);
			if (f2 > f1){
				sw1[0] = 1;
			}else {
				sp *= 2.0;
				f1  = f2;
			}
		}
		//-------Ԃ܂Ȃ
		if (sw1[0] == 0){
			sw = -2;
		}else { // Ԃ܂
			// @
			k = gold(0.0, sp, eps, y2, sw1, max, x, dx, kn);
			if (sw1[0] < 0){ // @s
				sw = -3;
			}else {// @
				//-------V_
				for (i1 = 0; i1 < n; i1++){
					x[i1] += k * dx[i1];
				}
				//-----֐l̕ω傫
				if (Math.abs(y1[0]-y2[0]) > eps) {
					y1[0] = y2[0];
					s1    = s2;
				}else { // i֐l̕ωj
					y[0] = y2[0];
				}
			}
		}

		//----------
		return( y2[0] );
	}
	//----------------
	public double [] getBestParam(){
		return( x );
	}
	/********************************************************************/
	/*     @(^ꂽł̍ŏl)                         */
	/*          a,b :  a < b                                    */
	/*          eps : e덷                                          */
	/*          val : ֐l                                            */
	/*          ind : vZ                                          */
	/*                  >= 0 : I()                       */
	/*                  = -1 :                                  */
	/*          max : ő厎s                                      */
	/*          w : ʒu                                                */
	/*          dw : X̐                                         */
	/*          kn : ֐lvZNXIuWFNg */
	/*          return : (w{ydwy)                              */
	/********************************************************************/
	public double gold(double a, double b, double eps, double val[], int ind[], int max,
                       double w[], double dw[], Kansu kn)
	{
		double f1, f2, fa, fb, tau = 0.618, x = 0.0, x1, x2;
		int count = 0;
					// ݒ
		ind[0] = -1;
		x1     = b - tau * (b - a);
		x2     = a + tau * (b - a);
		f1     = kn.snx(x1, w, dw);
		f2     = kn.snx(x2, w, dw);
					// vZ
		while (count < max && ind[0] < 0) {
			count += 1;
			if (f2 > f1) {
				if (Math.abs(b-a) < eps) {
					ind[0] = 0;
					x      = x1;
					val[0] = f1;
				}
				else {
					b  = x2;
					x2 = x1;
					x1 = a + (1.0 - tau) * (b - a);
					f2 = f1;
					f1 = kn.snx(x1, w, dw);
				}
			}
			else {
				if (Math.abs(b-a) < eps) {
					ind[0] = 0;
					x      = x2;
					val[0] = f2;
					f1     = f2;
				}
				else {
					a  = x1;
					x1 = x2;
					x2 = b - (1.0 - tau) * (b - a);
					f1 = f2;
					f2 = kn.snx(x2, w, dw);
				}
			}
		}
					// ꍇ̏
		if (ind[0] == 0) {
			ind[0] = count;
			fa     = kn.snx(a, w, dw);
			fb     = kn.snx(b, w, dw);
			if (fb < fa) {
				a  = b;
				fa = fb;
			}
			if (fa < f1) {
				x      = a;
				val[0] = fa;
			}
		}

		return x;
	}


}




// [⑫]===========================================================
