// ================================================================================
// 
// 璷RxA[̃[`O  
// e֐߂̊pxp[^ƂāAA[[^[QbgWɈvp[^
// TĂB
// Ae֐߂̓Nm}90xȓŌq񂪂̂ŁA
// Ȃׂ֐߂̉pxt߂̊pxɂ̂D܂ƂłB
// A[̐[^[QbgWɋ߂Ae֐߂̉px
// ΍̂Q捇vقǃRXg֐Ȃ܂B
// ----------------------------------------------------------
//
// ӌE₢킹͈ȉURLɃ[AhX܂̂ŁA
// 炩炨肢܂F
// http://sysplan.nams.kyushu-u.ac.jp/gen/index.html 
//
// Copyright 2006 Hajime Kimura, Kyushu Univ.
// Bw@w@Hw@ CmVXeHw ؑ 
// 
// 
// ================================================================================

import java.awt.Graphics;
import java.awt.Color;
import java.applet.*;
import java.io.*;

// ================================================================================
public class MultiJointArm {

	// --------------------------------------------------
	// {bg̊eʂ̃p[^
	// --------------------------------------------------
	public static final double armLength   = 0.8 ;   // A[S
	public static final double base_x      = 0.2;   // A[xW
	public static final double base_y      = 0.5 ;   // A[yW
	public static final double goal_x      = 0.3 ;   // S[GAx
	public static final double goal_y      = 0.8 ;   // S[GAy
	// --------------------------------------------------
	int numOfJoints   ; // A[\WCg
	double linkLength ; // A[\郊N̒
	double[] x ;        // eWCgɂȂ郊N[xW
	double[] y ;        // eWCgɂȂ郊N[yW
	double[] theta;     // eWCgɂȂ郊N̊px(rad)B
	                    // theta[0] ƃWCg1ԃN̐Ƃpx  
	                    // theta[i] WCg[i-1]ƃWCg[i] 邢͒[ԃN̊px 
	int action_dim ;    // s
	double rwd_x ;      // ڕWxW
	double rwd_y ;      // ڕWyW
	double cost ;

	// --------------------------------------------------
	// RXgN^
	// --------------------------------------------------
	MultiJointArm(int numberOfJoints ) {
		if( numberOfJoints < 2){
			numberOfJoints = 2 ;
		}
		numOfJoints = numberOfJoints ;       // A[\WCg
		linkLength  = armLength / ((double)numberOfJoints) ;   // A[\郊N̒ = A[S / WCg
		action_dim  = numberOfJoints ;   // s
		// ݒiftHgݒj---------------------------------
		x       = new double[numOfJoints+1]; // eWCgɂȂ郊N[xW
		y       = new double[numOfJoints+1]; // eWCgɂȂ郊N[yW
		theta   = new double[numOfJoints];   // eWCgɂȂ郊N̊px(rad)B
		//---------------------------------
		// ڕWW̐ݒ
		rwd_x = goal_x;   // ڕWxW
		rwd_y = goal_y;   // ڕWyW
		//--------------------------------------
		cost = 0; 
	}

	// --------------------------------------------------
	// p[^̗vf̑m点郁\bh
	// --------------------------------------------------
	public String GetConfig() {
		StringBuffer StrBuf = new StringBuffer() ;
		StrBuf.append("NumOfParameters  ").append( GetNumOfParameters() ).append("\n") ;
		for( int i = 0; i < GetNumOfParameters() ; i++ ){
			StrBuf.append("ParamRangeMin  -1  ParamRangeMax 1 \n" );     
		}
		return( StrBuf.toString() );
	}  

	// --------------------------------------------------
	// p[^̎m点郁\bh
	// --------------------------------------------------
	public int GetNumOfParameters() {
		return( numOfJoints );
	} 
	// --------------------------------------------------
	// ڕWʒuWݒ肷郁\bh
	// --------------------------------------------------
	public void SetGoal( double x, double y){
		rwd_x = x ;   // ڕWxW
		rwd_y = y ;   // ڕWyW
	}
	// ----------------------------------------------------------------------
	// Ŏꂽp[^]郁\bh(Ԃl=RXg)
	// ----------------------------------------------------------------------
	public double Evaluate( double[] ActionData ) {
		//-----Ƃė^ꂽp[^̃W␳
		for( int i = 0; i < action_dim; i++ ) {
			if( ActionData[i] > 1 ) {
				ActionData[i] = 1;
			}else if( ActionData[i] < -1 ) {
				ActionData[i] = -1;
			}
		}
		//-------p[^̒lɑΉ֐ߊpxZo
		double[] thetaDest = new double[action_dim];
		for( int i = 0; i < action_dim; i++ ) {
			thetaDest[i] = (3.14159 * 0.5) * (double)ActionData[i] ;
		}
		//-------e֐߁iуA[[j̍WvZ
		double totalTheta = 0;
		x[0] = base_x ;
		y[0] = base_y ;
		for( int i = 0; i < action_dim; i++ ) {
			theta[i] = thetaDest[i] ;
			totalTheta  += theta[i] ;
			x[i+1] = x[i] + (linkLength * Math.cos( totalTheta )) ;
			y[i+1] = y[i] + (linkLength * Math.sin( totalTheta )) ;
		}
		//--------RXg֐vZ
		cost  = ((x[action_dim] - rwd_x)*(x[action_dim] - rwd_x)*2500) ; // ڕWxWƂ2΍
		cost += ((y[action_dim] - rwd_y)*(y[action_dim] - rwd_y)*2500) ; // ڕWyWƂ2΍
		for( int i = 0; i < action_dim; i++ ) {
			cost += (ActionData[i] * ActionData[i]*4); // e֐߂̒ʒu2΍
		}
		return( cost );	
	}

	// ==================================================
	// ȉAʕ\֘A
	// ==================================================
	int img_width = 64;
	int img_height = 64;
	AudioClip walk_l;
	AudioClip walk_r;
	boolean SoundSw;
	// --------------------------------------------------
	// \p\bh
	// --------------------------------------------------
	public boolean InitDisp( int width, int height ) {
		img_width = width;     // ^ꂽōď
		img_height = height;   // ^ꂽōď
		return( true );
	}

	// --------------------------------------------------
	// ʏ̃{bg\p\bh
	// CostFuncRoboWin.javaɂČĂ΂Ă
	// --------------------------------------------------
	public void DispEnvironment( Graphics offscreenGraphics ) {
		// wih
		offscreenGraphics.setColor( Color.black );
		offscreenGraphics.fillRect( 0, 0, img_width, img_height );
		// S[ʒuɉ~`--------
		offscreenGraphics.setColor( Color.cyan );
		double tmpx ;
		double tmpy ;
		double wx = 0.04 * (double)img_width ;
		double wy = 0.04 * (double)img_height ; 
		tmpx = (rwd_x - 0.04/2) * (double)img_width ;
		tmpy = (1 - (rwd_y + 0.04/2)) * (double)img_height ; 
		offscreenGraphics.fillOval( (int)tmpx , (int)tmpy, (int)wx, (int)wy );
		//--------A[`
		offscreenGraphics.setColor( Color.white );
		int[] xi_array ;
		int[] yi_array ;
		xi_array = new int[numOfJoints+1];
		yi_array = new int[numOfJoints+1];
		for( int i = 0; i < numOfJoints+1; i++ ){
			tmpx = x[i] * (double)img_width ;
			tmpy = (1 - y[i]) * (double)img_height ; 
			xi_array[i] = (int)tmpx ;
			yi_array[i] = (int)tmpy ;
		}
		for( int i = 0; i < numOfJoints; i++ ){
			offscreenGraphics.drawLine( xi_array[i] , yi_array[i], xi_array[i+1], yi_array[i+1] ); 
		}
		//---_̖{(x,y)}ŕ\
		offscreenGraphics.setColor( Color.yellow );   // {͉F
		wx = 0.02 * (double)img_width ;
		wy = 0.02 * (double)img_height ; 
		for( int i = 0; i < numOfJoints; i++ ){
			tmpx = (x[i] - 0.02/2) * (double)img_width ;
			tmpy = (1 - (y[i] + 0.02/2)) * (double)img_height ; 
			offscreenGraphics.drawOval( (int)tmpx , (int)tmpy, (int)wx, (int)wy );
		}
		//---]l\
		String costStr = " cost = " + cost;
		offscreenGraphics.setColor( Color.white );
		offscreenGraphics.drawString( costStr, 16, img_height -20 );
	}
}
